type sign = Positive | Negative;;
(* type sign = Positive | Negative *)

let sign_int n = if n >= 0 then Positive else Negative;;
(* val sign_int : int -> sign = <fun> *)

let add_num n1 n2 =
  match (n1, n2) with
    (Int i1, Int i2) ->
      (* Check for map_overflow of integer addition *)
      if sign_int i1 = sign_int i2 && sign_int(i1 + i2) <> sign_int i1
      then Float(float i1 +. float i2)
      else Int(i1 + i2)
  | (Int i1, Float f2) -> Float(float i1 +. f2)
  | (Float f1, Int i2) -> Float(f1 +. float i2)
  | (Float f1, Float f2) -> Float(f1 +. f2)
  | (Error, _) -> Error
  | (_, Error) -> Error;;
(* val add_num : number -> number -> number = <fun> *)

sign_int 14;;

add_num (Int 123) (Float 3.14159);;
(* - : number = Float 126.14159 *)
